/* _bbcim_code.c
 *
 * (C) W.H.Scholten 2001
 */

int bbcim_data_crc(void *data, int length) {
	int  i;
	unsigned char *d = (unsigned char *) data;
	unsigned int crc;

	crc = 0;

	for (i=0; i<length; i++) {
		int  k;

		crc ^= ((*d++) << 8);
		for(k=0; k<8; k++) {
			if (crc & 32768) crc = (((crc ^ 0x0810) & 32767) << 1)+1;
			else crc <<= 1;
		}
	}

	return crc;
}

/* Following code is from bbcim 0.99: */
char bbcim_filename_chars_bad[]     = { '\\', '/', ':', '*', '?', '\"', '<', '>', '|', '.', '`', '\'' };
char bbcim_filename_chars_replace[] = { '_' , '_', '_', '_', '_', '_' , '_', '_', '_', '_', '_', '_' };

/* Number of char's to be checked for replacement */
#define  bbcim_no_filename_chars  sizeof(bbcim_filename_chars_bad)

void bbcim_replace_bad_chars(char *unix_bbcfile_naam) {
	/* Name check: replace certain characters in filenames (most filesystems
	 * can't handle all characters from bbc filenames)
	 */
	unsigned int i, j;

	for (j=0; j<strlen(unix_bbcfile_naam); j++) {
		if (unix_bbcfile_naam[j] < 32 || unix_bbcfile_naam[j] > 126)
			unix_bbcfile_naam[j] = '_';
		else {
			for (i=0; i<bbcim_no_filename_chars; i++) {
				if (unix_bbcfile_naam[j] == bbcim_filename_chars_bad[i]) {
					unix_bbcfile_naam[j] = bbcim_filename_chars_replace[i];
					break;
				}
			}
		}
	}
}

/* returns True if all chars are printable (>=32 and <=126), False if not;
 * Unprintable characters are replaced by '?' */
int bbcim_printable_bbcfilename(char *name) {
	int printable = true;
	int i;

	for (i=strlen(name)-1; i>=0; i--) {
		if (((unsigned char)name[i]) < 32 || ((unsigned char)name[i]) > 126) {
			name[i] = '?';
			printable = false;
		}
	}

	return printable;
}
