int  abuf_size;
u_char AUDIO_DEV[30] = DEFAULT_AUDIO_DEV;

int audio_open(int mode) {
	int audio, dummy;

	if ((audio = open(AUDIO_DEV,mode,0))==-1) {
		perror(AUDIO_DEV);
		exit(-1);
	}
	dummy = 8;
	ioctl(audio, SNDCTL_DSP_SAMPLESIZE, &dummy);
	if (8 != dummy) {
		fprintf(stderr, "%s: Unable to set the sample size to 8 bit\n", command);
		exit(-1);
	}
	dummy = 0;
	if (ioctl(audio, SNDCTL_DSP_STEREO, &dummy)==-1) {
		fprintf(stderr, "%s: Unable to set mono\n", command);
		exit(-1);
	}
	dummy = SAMPLE_FREQ;
	if (ioctl(audio, SNDCTL_DSP_SPEED, &dummy) == -1) {
		fprintf(stderr, "%s: Unable to set audio speed\n", command);
		exit(-1);
	}

	abuf_size = 4096;
	ioctl(audio, SNDCTL_DSP_SETBLKSIZE, &abuf_size);

	ioctl(audio, SNDCTL_DSP_GETBLKSIZE, &abuf_size);
	if (abuf_size < 4096 || abuf_size > 65536) {
		if (abuf_size == -1)
			perror (AUDIO_DEV);
		else
			fprintf (stderr, "%s: Invalid audio buffers size %d\n", command, abuf_size);
		exit (-1);
	}
	return audio;
}
